Index: cpukit/libfs/Makefile.am
===================================================================
--- cpukit/libfs/Makefile.am	(revision 8bed60314e383fe461c03236857b9ba369beecd4)
+++ cpukit/libfs/Makefile.am	(revision d2e0bb36e34f1fe45641f26b8b8d6ef615963854)
@@ -82,4 +82,5 @@
     src/dosfs/msdos_mknod.c src/dosfs/msdos_node_type.c \
     src/dosfs/msdos_rmnod.c src/dosfs/msdos_statvfs.c \
+    src/dosfs/msdos_conv_default.c \
     src/dosfs/msdos_conv.c src/dosfs/msdos.h src/dosfs/msdos_format.c \
     src/dosfs/dosfs.h src/dosfs/msdos_rename.c
Index: cpukit/libfs/src/dosfs/dosfs.h
===================================================================
--- cpukit/libfs/src/dosfs/dosfs.h	(revision 8bed60314e383fe461c03236857b9ba369beecd4)
+++ cpukit/libfs/src/dosfs/dosfs.h	(revision d2e0bb36e34f1fe45641f26b8b8d6ef615963854)
@@ -1,8 +1,8 @@
 /**
- * @file rtems/dosfs.h
- *
- * @brief Application Interface to MSDOS Filesystem
- *
- * @ingroup rtems_msdos_format
+ * @file
+ *
+ * @brief Application Interface to FAT Filesystem
+ *
+ * @ingroup DOSFS
  */
 
@@ -11,4 +11,7 @@
  *  Author: Eugeny S. Mints <Eugeny.Mints@oktet.ru>
  *
+ *  Modifications to support UTF-8 in the file system are
+ *  Copyright (c) 2013 embedded brains GmbH.
+ *
  *  The license and distribution terms for this file may be
  *  found in the file LICENSE in this distribution or at
@@ -26,4 +29,168 @@
 #endif
 
+typedef struct rtems_dosfs_convert_control rtems_dosfs_convert_control;
+
+/**
+ * @brief Converts from UTF-8 into a specific code page.
+ *
+ * @param[in/out] self The convert control.
+ * @param[in] src A well-formed UTF-8 string to be converted.
+ * @param[in] src_size The size of the string in bytes (inludes '\0' if any).
+ * @param[out] dst The address the converted string will get copied to.
+ * @param[in/out] dst_size The size of the buffer in bytes respectively the
+ * number of bytes written to the buffer.
+ *
+ * @retval 0 Successful operation.
+ * @retval EINVAL Conversion was successful, but is not reversible.
+ * @retval ENOMEM Conversion failed (possibly due to insufficient buffer size).
+ */
+typedef int (*rtems_dosfs_utf8_to_codepage)(
+  rtems_dosfs_convert_control *self,
+  const uint8_t               *src,
+  size_t                       src_size,
+  char                        *dst,
+  size_t                      *dst_size
+);
+
+/**
+ * @brief Converts from a specific code page into UTF-8
+ *
+ * @param[in/out] self The convert control.
+ * @param[in] src A well-formed string in code page format.
+ * @param[in] src_size The size of the string in bytes (inludes '\0' if any).
+ * @param[out] dst The address the converted string will get copied to.
+ * @param[in/out] dst_size The size of the buffer in bytes respectively the
+ * number of bytes written to the buffer.
+ *
+ * @retval 0 Successful operation.
+ * @retval EINVAL Conversion was successful, but is not reversible.
+ * @retval ENOMEM Conversion failed (possibly due to insufficient buffer size).
+ */
+typedef int (*rtems_dosfs_codepage_to_utf8)(
+  rtems_dosfs_convert_control *self,
+  const char                  *src,
+  size_t                       src_size,
+  uint8_t                     *dst,
+  size_t                      *dst_size
+);
+
+/**
+ * @brief Converts from UTF-8 to UTF-16
+ *
+ * @param[in/out] self The convert control.
+ * @param[in] src A well-formed UTF-8 string to be converted.
+ * @param[in] src_size The size of the string in bytes (inludes '\0' if any).
+ * @param[out] dst The address the converted string will get copied to
+ * @param[in/out] dst_size The size of the buffer in bytes respectively the
+ * number of bytes written to the buffer.
+ *
+ * @retval 0 Successful operation.
+ * @retval EINVAL Conversion was successful, but is not reversible.
+ * @retval ENOMEM Conversion failed (possibly due to insufficient buffer size).
+ */
+typedef int (*rtems_dosfs_utf8_to_utf16)(
+  rtems_dosfs_convert_control *self,
+  const uint8_t               *src,
+  size_t                       src_size,
+  uint16_t                    *dst,
+  size_t                      *dst_size
+);
+
+/**
+ * @brief Converts from UTF-16 to UTF-8.
+ *
+ * @param[in/out] self The convert control.
+ * @param[in] src A well-formed UTF-16 string to be converted.
+ * @param[in] src_size The size of the string in bytes (inludes '\0' if any).
+ * @param[out] dst The address the converted string will get copied to.
+ * @param[in/out] dst_size The size of the buffer in bytes respectively the
+ * number of bytes written to the buffer
+ *
+ * @retval 0 Successful operation.
+ * @retval EINVAL Conversion was successful, but is not reversible.
+ * @retval ENOMEM Conversion failed (possibly due to insufficient buffer size).
+ */
+typedef int (*rtems_dosfs_utf16_to_utf8)(
+  rtems_dosfs_convert_control *self,
+  const uint16_t              *src,
+  size_t                       src_size,
+  uint8_t                     *dst,
+  size_t                      *dst_size
+);
+
+/**
+ * @brief Converts from UTF-8 to Normalized Form Canonical Decomposition.
+ *
+ * Does canonical decomposition of the UTF-8 string and in addition
+ * also converts upper case alphabetic characters to lower case characters
+ *
+ * @param[in/out] self The convert control.
+ * @param[in] src A well-formed UTF-8 string to be normalized and fold.
+ * @param[in] src_size The size of the string in bytes (inludes '\0' if any).
+ * @param[out] dst The address the normalized and fold string will get
+ * copied to.
+ * @param[in/out] dst_size The size of the buffer in bytes respectively the
+ * number of bytes written to the buffer.
+ *
+ * @retval 0 Successful operation.
+ * @retval EINVAL Conversion failed.
+ * @retval ENOMEM Conversion failed (possibly due to insufficient buffer size).
+ * @retval EOVERFLOW Conversion failed.
+ * @retval ENOENT Conversion failed.
+ */
+typedef int (*rtems_dosfs_utf8_normalize_and_fold)(
+  rtems_dosfs_convert_control *self,
+  const uint8_t               *src,
+  size_t                       src_size,
+  uint8_t                     *dst,
+  size_t                      *dst_size
+);
+
+/**
+ * @brief Destroys a convert control structure.
+ *
+ * @param[in/out] self The convert control for destruction.
+ */
+typedef void (*rtems_dosfs_convert_destroy)(
+  rtems_dosfs_convert_control *self
+);
+
+/**
+ * @brief FAT filesystem convert handler.
+ */
+typedef struct {
+  rtems_dosfs_utf8_to_codepage        utf8_to_codepage;
+  rtems_dosfs_codepage_to_utf8        codepage_to_utf8;
+  rtems_dosfs_utf8_to_utf16           utf8_to_utf16;
+  rtems_dosfs_utf16_to_utf8           utf16_to_utf8;
+  rtems_dosfs_utf8_normalize_and_fold utf8_normalize_and_fold;
+  rtems_dosfs_convert_destroy         destroy;
+} rtems_dosfs_convert_handler;
+
+typedef struct {
+  void   *data;
+  size_t  size;
+} rtems_dosfs_buffer;
+
+/**
+ * @brief FAT filesystem convert control.
+ *
+ * Short file names are stored in the code page format.  Long file names are
+ * stored as little-endian UTF-16.  The convert control determines the format
+ * conversions to and from the POSIX file name strings.
+ */
+struct rtems_dosfs_convert_control {
+  const rtems_dosfs_convert_handler *handler;
+  rtems_dosfs_buffer                 buffer;
+};
+
+/**
+ * @defgroup DOSFS FAT Filesystem Support
+ *
+ * @ingroup FileSystemTypesAndMount
+ *
+ * @{
+ */
+
 /**
  * @brief Semaphore count per FAT filesystem instance.
@@ -33,14 +200,25 @@
 #define RTEMS_DOSFS_SEMAPHORES_PER_INSTANCE 1
 
-int rtems_dosfs_initialize(rtems_filesystem_mount_table_entry_t *mt_entry,
-                           const void                           *data);
-
-/**
- * @defgroup rtems_msdos_format DOSFS Support
- *
- * @ingroup FileSystemTypesAndMount
- *
- */
-/**@{**/
+/**
+ * @brief FAT filesystem mount options.
+ */
+typedef struct {
+  /**
+   * @brief Converter implementation for new filesystem instance.
+   *
+   * @see rtems_dosfs_create_default_converter().
+   */
+  rtems_dosfs_convert_control *converter;
+} rtems_dosfs_mount_options;
+
+/**
+ * @brief Allocates and initializes a default converter.
+ *
+ * @retval NULL Something failed.
+ * @retval other Pointer to initialized converter.
+ *
+ * @see rtems_dosfs_mount_options and mount().
+ */
+rtems_dosfs_convert_control *rtems_dosfs_create_default_converter(void);
 
 #define MSDOS_FMT_INFO_LEVEL_NONE   (0)
@@ -132,4 +310,7 @@
 /** @} */
 
+int rtems_dosfs_initialize(rtems_filesystem_mount_table_entry_t *mt_entry,
+                           const void                           *data);
+
 #ifdef __cplusplus
 }
Index: cpukit/libfs/src/dosfs/msdos.h
===================================================================
--- cpukit/libfs/src/dosfs/msdos.h	(revision 8bed60314e383fe461c03236857b9ba369beecd4)
+++ cpukit/libfs/src/dosfs/msdos.h	(revision d2e0bb36e34f1fe45641f26b8b8d6ef615963854)
@@ -10,4 +10,7 @@
  *  Copyright (C) 2001 OKTET Ltd., St.-Petersburg, Russia
  *  Author: Eugeny S. Mints <Eugeny.Mints@oktet.ru>
+ *
+ *  Modifications to support UTF-8 in the file system are
+ *  Copyright (c) 2013 embedded brains GmbH.
  *
  *  The license and distribution terms for this file may be
@@ -21,4 +24,5 @@
 #include <rtems.h>
 #include <rtems/libio_.h>
+#include <rtems/dosfs.h>
 
 #include "fat.h"
@@ -68,4 +72,6 @@
                                                             * for anything
                                                             */
+
+    rtems_dosfs_convert_control      *converter;
 } msdos_fs_info_t;
 
@@ -184,4 +190,6 @@
  *  Macros for names parsing and formatting
  */
+#define MSDOS_NAME_MAX_UTF8_BYTES_PER_CHAR  4
+#define MSDOS_NAME_MIN_UTF8_BYTES_PER_CHAR  1
 
 #define MSDOS_SHORT_BASE_LEN             8  /* 8 characters */
@@ -191,7 +199,18 @@
 #define MSDOS_NAME_MAX_LNF_LEN           (255)
 #define MSDOS_NAME_MAX                   MSDOS_SHORT_NAME_LEN
+#define MSDOS_NAME_MAX_UTF8_SFN_BYTES    (MSDOS_NAME_MAX *\
+                                         MSDOS_NAME_MAX_UTF8_BYTES_PER_CHAR)
 #define MSDOS_NAME_MAX_WITH_DOT          (MSDOS_NAME_MAX + 1)
+#define MSDOS_SFN_MAX_WITH_DOT_UTF8_BYTES (MSDOS_NAME_MAX_WITH_DOT *\
+                                           MSDOS_NAME_MAX_UTF8_BYTES_PER_CHAR)
 #define MSDOS_NAME_MAX_LFN_WITH_DOT      (260)
 
+#define MSDOS_NAME_LFN_BYTES_PER_CHAR    (2)
+#define MSDOS_NAME_MAX_LFN_BYTES         (MSDOS_NAME_MAX_LFN_WITH_DOT *\
+                                          MSDOS_NAME_LFN_BYTES_PER_CHAR)
+#define MSDOS_NAME_MAX_UTF8_LFN_BYTES    (MSDOS_NAME_MAX_LFN_WITH_DOT *\
+                                          MSDOS_NAME_MAX_UTF8_BYTES_PER_CHAR)
+#define MSDOS_ENTRY_LFN_UTF8_BYTES       (MSDOS_LFN_LEN_PER_ENTRY *\
+                                          MSDOS_NAME_MAX_UTF8_BYTES_PER_CHAR)
 
 extern const char *const MSDOS_DOT_NAME;    /* ".", padded to MSDOS_NAME chars */
@@ -310,5 +329,6 @@
   const rtems_filesystem_operations_table *op_table,
   const rtems_filesystem_file_handlers_r  *file_handlers,
-  const rtems_filesystem_file_handlers_r  *directory_handlers
+  const rtems_filesystem_file_handlers_r  *directory_handlers,
+  rtems_dosfs_convert_control             *converter
 );
 
@@ -388,8 +408,50 @@
 int msdos_dir_info_remove(rtems_filesystem_location_info_t *pathloc);
 
-msdos_name_type_t msdos_long_to_short(const char *lfn, int lfn_len,
+ssize_t
+msdos_format_dirent_with_dot(char *dst,const char *src);
+
+msdos_name_type_t msdos_long_to_short(rtems_dosfs_convert_control *converter,
+                                      const char *lfn, int lfn_len,
                                       char* sfn, int sfn_len);
 
-int msdos_filename_unix2dos(const char *un, int unlen, char *dn);
+ssize_t
+msdos_filename_utf8_to_short_name_for_compare (
+    rtems_dosfs_convert_control     *converter,
+    const uint8_t                   *utf8_name,
+    const size_t                     utf8_name_size,
+    void                            *short_name,
+    const size_t                     short_name_size);
+
+ssize_t
+msdos_filename_utf8_to_short_name_for_save (
+    rtems_dosfs_convert_control     *converter,
+    const uint8_t                   *utf8_name,
+    const size_t                     utf8_name_size,
+    void                            *short_name,
+    const size_t                     short_name_size);
+
+ssize_t
+msdos_filename_utf8_to_long_name_for_compare (
+    rtems_dosfs_convert_control     *converter,
+    const uint8_t                   *utf8_name,
+    const size_t                     utf8_name_size,
+    uint8_t                         *long_name,
+    const size_t                     long_name_size);
+
+ssize_t
+msdos_filename_utf8_to_long_name_for_save (
+    rtems_dosfs_convert_control     *converter,
+    const uint8_t                   *utf8_name,
+    const size_t                     utf8_name_size,
+    uint16_t                        *long_name,
+    const size_t                     long_name_size);
+
+ssize_t
+msdos_get_utf16_string_from_long_entry (
+  const char                 *entry,
+  uint16_t                   *entry_string_buf,
+  const size_t                buf_size,
+  bool                        is_first_entry
+);
 
 void msdos_date_unix2dos(
@@ -431,5 +493,5 @@
     fat_file_fd_t                        *fat_fd,
     bool                                  create_node,
-    const char                           *name,
+    const uint8_t                        *name_utf8,
     int                                   name_len,
     msdos_name_type_t                     name_type,
